/*  Copyright 2004-2009, Unpublished Work of Technologic Systems
 *  All Rights Reserved.
 *
 *  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 *  PROPRIETARY AND TRADE SECRET INFORMATION OF TECHNOLOGIC SYSTEMS.
 *  ACCESS TO THIS WORK IS RESTRICTED TO (I) TECHNOLOGIC SYSTEMS EMPLOYEES
 *  WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR
 *  ASSIGNMENTS  AND (II) ENTITIES OTHER THAN TECHNOLOGIC SYSTEMS WHO
 *  HAVE ENTERED INTO  APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS
 *  WORK MAY BE USED, PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED,
 *  MODIFIED, TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED,
 *  COMPILED,LINKED,RECAST, TRANSFORMED, ADAPTED IN ANY FORM OR BY ANY
 *  MEANS,MANUAL, MECHANICAL, CHEMICAL, ELECTRICAL, ELECTRONIC, OPTICAL,
 *  BIOLOGICAL, OR OTHERWISE WITHOUT THE PRIOR WRITTEN PERMISSION AND
 *  CONSENT OF TECHNOLOGIC SYSTEMS . ANY USE OR EXPLOITATION OF THIS WORK
 *  WITHOUT THE PRIOR WRITTEN CONSENT OF TECHNOLOGIC SYSTEMS  COULD
 *  SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
 */
#include <assert.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <linux/unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <time.h>
#include <limits.h>
#include <sched.h>
#include <libgen.h>
#include <time.h>
#include <signal.h>
#include <linux/i2c-dev.h>


static void poke8(unsigned int, unsigned char);
static void poke16(unsigned int, unsigned short);
static void poke32(unsigned int, unsigned int);
static unsigned char peek8(unsigned int);
static unsigned short peek16(unsigned int);
static unsigned int peek32(unsigned int);

volatile unsigned int *cvspiregs, *cvgpioregs, *cvtwiregs;
volatile unsigned int *cvmiscregs, *cvtimerregs;

volatile unsigned int *mxgpioregs, *mxtimerregs, *mxiomuxregs;
volatile unsigned short *sysconregs, *adcregs;

static int last_gpio_adr = 0;

extern signed char ispVM(char *);
const unsigned int g_ucPinTDI          = 1<<27;
const unsigned int g_ucPinTCK          = 1<<25;
const unsigned int g_ucPinTMS          = 1<<26;
const unsigned int g_ucPinENABLE       = 0;
const unsigned int g_ucPinTRST         = 0;
const unsigned int g_ucPinTDO          = 1<<30;

static void poke8(unsigned int adr, unsigned char dat) {
}
static void poke16(unsigned int adr, unsigned short dat) {
}
static void poke32(unsigned int adr, unsigned int dat) {
}

static unsigned char peek8(unsigned int adr) {
  return 0;
}
static unsigned short peek16(unsigned int adr) {
  return 0;
}
static unsigned int peek32(unsigned int adr) {
  return 0;
}

void sspi_cmd(unsigned int cmd) {
	unsigned int i;
	
	// pulse CS#
	sysconregs[0x14/2] = 0x2;
	sysconregs[0x14/2] = 0x0;

	for (i = 0; i < 32; i++, cmd <<= 1) {
		if (cmd & 0x80) {
			sysconregs[0x14/2] = 0x4;
			sysconregs[0x14/2] = 0xc;
		} else {
			sysconregs[0x14/2] = 0x0;
			sysconregs[0x14/2] = 0x8;
		}
	}
}

int read_tagmem(int *tagmem) {
	int i, j;
	unsigned int cmd, ret;

	sspi_cmd(0xac); // X_PROGRAM_EN
	sspi_cmd(0x4e); // READ_TAG
	
	for (j = 0; j < 24; j++) {
		for (ret = 0x0, i = 0; i < 32; i++) {
			sysconregs[0x14/2] = 0x0;
			sysconregs[0x14/2] = 0x8;
			ret = ret << 1 | (sysconregs[0x14/2] & 0x1);
		}
		tagmem[j] = ret;
	}
	
	sspi_cmd(0x78); // PROGRAM_DIS
	
	sysconregs[0x14/2] = 0x2;
	return 1;
}

int write_tagmem(int *tagmem) {
	int i, j;
	unsigned int cmd, ret;
	
	sspi_cmd(0xac); // X_PROGRAM_EN
	sspi_cmd(0x8e); // WRITE_TAG
	
	for (j = 0; j < 24; j++) {
		unsigned int x = tagmem[j];
		for (i = 0; i < 32; i++, x <<= 1) {
			if (x & 0x80000000UL) {
				sysconregs[0x14/2] = 0x4;
				sysconregs[0x14/2] = 0xc;
			} else {
				sysconregs[0x14/2] = 0x0;
				sysconregs[0x14/2] = 0x8;
			}
		}
	}
	
	for (i = 0; i < 8; i++) {
		sysconregs[0x14/2] = 0x2;
		sysconregs[0x14/2] = 0xa;
	}
	sysconregs[0x14/2] = 0x2;
	usleep(25000);
	
	return 1;
}

int erase_tagmem() {
	int i, j;
	unsigned int cmd, ret;

	sspi_cmd(0xac); // X_PROGRAM_EN
	sspi_cmd(0xe); // ERASE_TAG

	for (i = 0; i < 8; i++) {
		sysconregs[0x14/2] = 0x2;
		sysconregs[0x14/2] = 0xa;
	}
	sysconregs[0x14/2] = 0x2;
	usleep(1000000);

	return 1;
}

int getbaseboardid() {
       int i,gled,rled,dio25,dio25dir;
       int value = 0;

       gled = (sysconregs[0x10/2] >> 15) & 0x1;
       rled = (sysconregs[0x10/2] >> 14) & 0x1;
       dio25 = (sysconregs[0x32/2] >> 6) & 0x1;
       dio25dir = (sysconregs[0x34/2] >> 6) & 0x1;
       sysconregs[0x24/2] &= ~(0x1 << 5);
       sysconregs[0x34/2] |= (0x1 << 6);
       for (i=7;i>=0;i--) {
		if (i&1) sysconregs[0x10/2] &= ~(0x1 << 14);
		else sysconregs[0x10/2] |= (0x1 << 14);
		if (i&2) sysconregs[0x10/2] &= ~(0x1 << 15);
		else sysconregs[0x10/2] |= (0x1 << 15);
		if (i&4) sysconregs[0x32/2] |= (0x1 << 6);
		else sysconregs[0x32/2] &= ~(0x1 << 6);
	       value <<= 1;
	       if (((sysconregs[0x20/2] >> 5) & 0x1)) value |= 1;
       }
       if (rled) sysconregs[0x10/2] |= (0x1 << 14);
       else sysconregs[0x10/2] &= ~(0x1 << 14);
       if (gled) sysconregs[0x10/2] |= (0x1 << 15);
       else sysconregs[0x10/2] &= ~(0x1 << 15);
       if (dio25) sysconregs[0x32/2] |= (0x1 << 6);
       else sysconregs[0x32/2] &= ~(0x1 << 6);
       if (dio25dir) sysconregs[0x34/2] |= (0x1 << 6);
       else sysconregs[0x34/2] &= ~(0x1 << 6);
       
       return value;
}


static void reservemem(void) {
	char dummy[32768];
	int i, pgsize;
	FILE *maps;

	pgsize = getpagesize();
	mlockall(MCL_CURRENT|MCL_FUTURE);
	for (i = 0; i < sizeof(dummy); i += 4096) {
		dummy[i] = 0;
	}

	maps = fopen("/proc/self/maps", "r"); 
	if (maps == NULL) {
		perror("/proc/self/maps");
		exit(1);
	}
	while (!feof(maps)) {
		unsigned int s, e, i;
		char m[PATH_MAX + 1];
		char perms[16];
		int r = fscanf(maps, "%x-%x %s %*x %*x:%*x %*d",
		  &s, &e, perms);
		if (r == EOF) break;
		assert (r == 3);

		i = 0;
		while ((r = fgetc(maps)) != '\n') {
			if (r == EOF) break;
			m[i++] = r;
		}
		m[i] = '\0';
		assert(s <= e && (s & 0xfff) == 0);
		if (perms[0] == 'r') while (s < e) {
			unsigned char *ptr = (unsigned char *)s;
			*ptr;
			s += pgsize;
		}
	}
}

unsigned last_adrs;
int i2cfd=1;

void write_TWI_data(unsigned adrs,int len,unsigned data) {
  int ret;
  last_adrs = data & 0x0F;
  adrs >>= 1;
  assert(ioctl(i2cfd, 0x0703, adrs) == 0);
  write(i2cfd,&data,len);
}
unsigned read_TWI_data(unsigned adrs,int len) {
  unsigned val;
  read(i2cfd,&val,len);
  return val;
}
void LM73_power(int on) {
  write_TWI_data(0x92,2,0x4001 | (((on==0)?1:0) << 15));
}

/* Returns I2C temp in *val in milliCelsius */
int read_LM73_temp(int *val) {
	unsigned data;

	i2cfd=open("/dev/i2c-1", O_RDWR);
	assert(i2cfd != 0);

	write_TWI_data(0x92,1,0x7);
	data = read_TWI_data(0x92,2);
	if (((data & 0xFF) != 0x01) ||  (((data >> 8) & 0xFF) != 0x90)) 
		return -1;

	write_TWI_data(0x92,1,0x1);
	LM73_power(0);
	usleep(150000);
	LM73_power(1);
	usleep(150000);

	write_TWI_data(0x92,1,0x0);
	data = read_TWI_data(0x92,2);
	*val = ((data & 0xFF) << 8) + ((data >> 8) & 0xFF);
	// *val = (*val * 1000) / 128;
	return 0;
}

static void usage(char **argv) {
	fprintf(stderr, "Usage: %s [OPTION] ...\n"
	  "Technologic Systems TS-4800 FPGA manipulation.\n"
	  "\n"
	  "General options:\n"
	  "  -g, --getmac            Display ethernet MAC address\n"
	  "  -s, --setmac=MAC        Set ethernet MAC address\n"
	  "  -R, --reboot            Reboot the board\n"
	  "  -i, --info              Display board FPGA info\n"
	  "  -e, --greenledon        Turn green LED on\n"
	  "  -b, --greenledoff       Turn green LED off\n"
	  "  -c, --redledon          Turn red LED on\n"
	  "  -d, --redledoff         Turn red LED off\n"
	  "  -D, --setdio=LVAL       Set DIO output to LVAL\n"
	  "  -O, --setdiodir=LVAL    Set DIO direction to LVAL (1 - output)\n"
	  "  -G, --getdio            Get DIO input\n"
	  "  -Z, --getdioreg         Get DIO direction and output register values\n"
	  "  -x, --random            Get 16-bit hardware random number\n"
	  "  -W, --watchdog          Daemonize and set up /dev/watchdog\n"
	  "  -A, --autofeed=SETTING  Daemonize and auto feed watchdog\n"
	  "  -n, --setrng            Seed the kernel random number generator\n"
	  "  -X, --resetswitchon     Enable reset switch\n"
	  "  -Y, --resetswitchoff    Disable reset switch\n"
	  "  -l, --loadfpga=FILE     Load FPGA bitstream from FILE\n"
	  "  -T, --gettemp           Print board temperature\n"
	  "  -P, --gpuon             Allocates 96MB at startup for the GPU\n"
      	  "  -p, --gpuoff            Disable GPU\n"
	  "  -h, --help              This help\n",
	  argv[0]
	);
}
int main(int argc, char **argv) {
	int devmem, i, j, c, ret, wdog;
	char *n;
	unsigned int tagmem[24];
	int opt_getmac = 0, opt_setmac = 0, opt_reboot = 0;
	int opt_info = 0, opt_greenledon = 0;
	int opt_greenledoff = 0, opt_redledon = 0, opt_redledoff = 0;
	int opt_setdio = 0, opt_setdiodir = 0, opt_getdio = 0, opt_random = 0;
	int opt_watchdog = 0, opt_autofeed = 0, opt_resetswitchon = 0;
	int opt_resetswitchoff = 0, opt_extendedtempon = 0, opt_gettemp = 0;
	int opt_extendedtempoff = 0, opt_getdioreg = 0, opt_setrng = 0;
	int opt_gpuon = 0, opt_gpuoff = 0, opt_adc = 0;
	int opt_getborn=0, opt_setborn=0, bornon=0;
	unsigned long long dio, oe;
	char *opt_mac, *opt_loadfpga = NULL;
	static struct option long_options[] = {
	  { "help", 0, 0, 'h' },
	  { "getmac", 0, 0, 'g' },
	  { "setmac", 1, 0, 's' },
	  { "reboot", 0, 0, 'R' },
	  { "greenledon", 0, 0, 'e'},
	  { "greenledoff", 0, 0, 'b'},
	  { "redledon", 0, 0, 'c'},
	  { "redledoff", 0, 0, 'd'},
	  { "setdio", 1, 0, 'D'},
	  { "setdiodir", 1, 0, 'O'},
	  { "getdio", 0, 0, 'G'},
	  { "getdioreg", 0, 0, 'Z'},
	  { "info", 0, 0, 'i' },
	  { "random", 0, 0, 'x' },
	  { "watchdog", 0, 0, 'W' },
	  { "autofeed", 1, 0, 'A' },
	  { "setrng", 0, 0, 'n' },
	  { "resetswitchon", 0, 0, 'X' },
	  { "resetswitchoff", 0, 0, 'Y' },
	  { "loadfpga", 1, 0, 'l' },
	  { "gettemp", 0, 0, 'T' },
	  { "getborn", 0, 0, 'u' },
      { "setborn", 1, 0, 'U' },
	  { "gpuon", 0, 0, 'P' },
	  { "gpuoff", 0, 0, 'p' },
      { "adc", 0, 0, 'a' },
	  { 0, 0, 0, 0 }
	};

	while((c = getopt_long(argc, argv,
	  "hra:w:gs:RiebcdD:O:GxWA:XYZl:nTpPuU:", long_options, NULL)) != -1) {
		switch (c) {
		case 'T':
			opt_gettemp = 1;
			break;
		case 'n':
			opt_setrng = 1;
			break;
		case 'l':
			opt_loadfpga = strdup(optarg);
			break;
		case 'Z':
			opt_getdioreg = 1;
			break;
		case 'X':
			opt_resetswitchon = 1;
			break;
		case 'Y':
			opt_resetswitchoff = 1;
			break;
		case 'W':
			opt_watchdog = 1;
			break;		
		case 'a':
			opt_adc = 1;
			break;
		case 'A':
			opt_watchdog = 1;
			opt_autofeed = 1;
			wdog = strtoul(optarg, NULL, 0);
			if (wdog > 3) {
				fprintf(stderr, 
				  "autofeed must be between 0 and 3\n");
				exit(1);
			}
			break;
		case 'D':
			opt_setdio = 1;	
			dio = strtoull(optarg, NULL, 0);
			break;
		case 'O':
			opt_setdiodir = 1;
			oe = strtoull(optarg, NULL, 0);
			break;
		case 'G':
			opt_getdio = 1;
			break;
		case 'e':
			opt_greenledon = 1;
			break;
		case 'b':
			opt_greenledoff = 1;
			break;
		case 'c':
			opt_redledon = 1;
			break;
		case 'd':
			opt_redledoff = 1;
			break;
		case 'i':
			opt_info = 1;
			break;
		case 's':
			opt_setmac = 1;
			opt_mac = strdup(optarg);
			break;
		case 'g':
			opt_getmac = 1;
			break;
		case 'R':
			opt_reboot = 1;
			break;
		case 'x':
			opt_random = 1;
			break;
		case 'P':
			opt_gpuon = 1;
			break;
		case 'u':
		   	opt_getborn = 1;
		   	break;
		case 'U':
		   	opt_setborn = 1;
		   	bornon = strtoull(optarg, NULL, 0);
		   	break;
		case 'p':
			opt_gpuoff = 1;
			break;
		case 'h':
		default:
			usage(argv);
			return(1);
		}
	}

	devmem = open("/dev/mem", O_RDWR|O_SYNC);
	assert(devmem != -1);
	
	mxgpioregs = (unsigned int *) mmap(0, 4096,
	  PROT_READ | PROT_WRITE, MAP_SHARED, devmem, 0x73f8c000);
	mxiomuxregs = (unsigned int *) mmap(0, 4096,
          PROT_READ | PROT_WRITE, MAP_SHARED, devmem, 0x73fa8000);
	sysconregs = (unsigned short *) mmap(0, 4096,
          PROT_READ | PROT_WRITE, MAP_SHARED, devmem, 0xb0010000);
    if (opt_adc) adcregs = (unsigned short *) mmap(0, 4096,
          PROT_READ | PROT_WRITE, MAP_SHARED, devmem, 0xb0016000);

	if (opt_loadfpga) {
		key_t shmkey;
		int shmid;
		unsigned int prev_gpio_dir, prev_gpio_dat;
		unsigned int prev_iomux_168, prev_iomux_15c, prev_iomux_158, prev_iomux_154;
		signed char x;
		const char * ispvmerr[] = { "pass", "verification fail", 
		  "can't find the file", "wrong file type", "file error", 
		  "option error", "crc verification error" };

		//mxtimerregs = (unsigned int *) mmap(0, 4096, 
		//  PROT_READ | PROT_WRITE, MAP_SHARED, devmem, 0x79000000);

		prev_gpio_dir = mxgpioregs[0x4/4];
		prev_gpio_dat = mxgpioregs[0x0/4];
		prev_iomux_168 = mxiomuxregs[0x168/4];
		prev_iomux_15c = mxiomuxregs[0x15c/4];
		prev_iomux_158 = mxiomuxregs[0x158/4];
		prev_iomux_154 =  mxiomuxregs[0x154/4]; 

		mxiomuxregs[0x168/4] = 0x13;
                mxiomuxregs[0x15c/4] = 0x13;
                mxiomuxregs[0x158/4] = 0x13;
                mxiomuxregs[0x154/4] = 0x13;

		mxgpioregs[0x4/4] |= (1<<25|1<<26|1<<27); 
		mxgpioregs[0x4/4] &= ~(1<<30);

		x = ispVM(opt_loadfpga);
		if (x == 0) {
			printf("loadfpga_ok=1\n");
		} else {
			assert(x < 0);
			printf("loadfpga_ok=0\n");
			printf("loadfpga_error=\"%s\"\n", ispvmerr[-x]);
		}

		mxiomuxregs[0x168/4] = prev_iomux_168;
                mxiomuxregs[0x15c/4] = prev_iomux_15c;
                mxiomuxregs[0x158/4] = prev_iomux_158;
                mxiomuxregs[0x154/4] = prev_iomux_154;
		mxgpioregs[0x0/4] = prev_gpio_dat;
		mxgpioregs[0x4/4] = prev_gpio_dir;
	} 

	if (opt_gettemp) {
		ret = read_LM73_temp(&i);
		printf("tempsensor_ok=%d\n", ret == -1 ? 0 : 1);
		//printf("temperature=%d.%03d\n", i/1000, abs(i%1000));
		printf("temperature=%.2fC\n",(float)i/128);
	}

	if (opt_random) {
		i = sysconregs[0xc/2];
		printf("random=0x%x\n", i);
	}

	if (opt_setrng) {
		FILE *urandom = NULL;
		unsigned short rng = peek16(0x64);

		urandom = fopen("/dev/urandom", "w");
		assert(urandom != NULL);
		fwrite(&rng, 2, 1, urandom);
		fclose(urandom);
	}

	if (opt_resetswitchon) {
		unsigned short x;
		x = peek16(0x76);
		x |= 0x10;
		poke16(0x76, x);
	} else if (opt_resetswitchoff) {
		unsigned short x;
		x = peek16(0x76);
		x &= ~0x10;
		poke16(0x76, x);
	}

	if (opt_info) {
		int a, b, c;
		unsigned short x = 0;
		a = sysconregs[0x0/2];
		b = sysconregs[0x2/2];
		c = sysconregs[0x16/2];
		if (a == 0x4800) x = getbaseboardid();
		printf("model=0x%x\n", a);
		if (a == 0x4800) printf("baseboard_model=0x%x\n", x);
		printf("submodel=0x%x\n", (b >> 4) & 0xf);
		printf("revision=0x%x\n", b & 0xf);
		printf("bootmode=0x%x\n", (b >> 12) & 0x1 );
		printf("bootdev=0x%x\n", (c >> 2) & 0x3);
		printf("resetsw_en=0x%x\n", (c >> 4) & 0x1);
		printf("latched_dio9=0x%x\n", (c >> 5) & 0x1);
		opt_getdio = 1;
	}

	if (opt_getdio) {
		unsigned long long v;
		v = (unsigned long long)sysconregs[0x20/2];
		v |= (unsigned long long)sysconregs[0x28/2] << 16;
		v |= (unsigned long long)sysconregs[0x30/2] << 32;
		v |= (unsigned long long)sysconregs[0x38/2] << 48;
		printf("dio=0x%llx\n", v);
	}

	if (opt_setdio) {
                unsigned int x;
                x = (dio) & 0xffff;
                sysconregs[0x22/2] = x;
                x = (dio >> 16) & 0xffff;
                sysconregs[0x2a/2] = x;
                x = (dio >> 32) & 0xffff;
                sysconregs[0x32/2] = x;
                x = (dio >> 48) & 0xff;
                sysconregs[0x3a/2] = x;
	}

	if (opt_setdiodir) {
		unsigned int x;
		x = (oe) & 0xffff;
		sysconregs[0x24/2] = x;
		x = (oe >> 16) & 0xffff;
		sysconregs[0x2c/2] = x;
		x = (oe >> 32) & 0xffff;
		sysconregs[0x34/2] = x;
		x = (oe >> 48) & 0xff;
		sysconregs[0x3c/2] = x;
	}

	if (opt_getdioreg) {
		unsigned long long v, v2;
                v = (unsigned long long)sysconregs[0x24/2];
                v |= (unsigned long long)sysconregs[0x2c/2] << 16;
                v |= (unsigned long long)sysconregs[0x34/2] << 32;
                v |= (unsigned long long)sysconregs[0x3c/2] << 48;
		v2 = (unsigned long long)sysconregs[0x22/2];
                v2 |= (unsigned long long)sysconregs[0x2a/2] << 16;
                v2 |= (unsigned long long)sysconregs[0x32/2] << 32;
                v2 |= (unsigned long long)sysconregs[0x3a/2] << 48;
		printf("diodir=0x%llx\n", v);
		printf("dio_out=0x%llx\n", v2);
	}

	if (opt_getdio && (opt_setdiodir || opt_setdio)) {
		unsigned long long v;
                v = (unsigned long long)sysconregs[0x20/2];
                v |= (unsigned long long)sysconregs[0x28/2] << 16;
                v |= (unsigned long long)sysconregs[0x30/2] << 32;
                v |= (unsigned long long)sysconregs[0x38/2] << 48;
		printf("dio2=0x%llx\n", v);
	}

	if (opt_getmac) {
		unsigned char a, b, c;
		read_tagmem(tagmem);
		a = tagmem[0] >> 24; 
		b = tagmem[0] >> 16; 
		c = tagmem[0] >> 8; 
		printf("mac=00:d0:69:%02x:%02x:%02x\n", a, b, c);
	}
	
	if (opt_getborn) {
	    	read_tagmem(tagmem);
            	printf("%d\n", tagmem[1]);
	}

	if (opt_setborn) {
	    	read_tagmem(tagmem);
	    	tagmem[1] = bornon;
	    	erase_tagmem();
       		write_tagmem(tagmem);
	}

	if (opt_setmac) {
		unsigned int a, b, c;
		int r;
		r = sscanf(opt_mac, "%*x:%*x:%*x:%x:%x:%x",  &a, &b, &c);
		assert(r == 3); /* XXX: user arg problem */
		assert(a < 0x100);
		assert(b < 0x100);
		assert(c < 0x100);
		read_tagmem(tagmem);
		erase_tagmem();
		tagmem[0] &= ~0xffffff00;
		tagmem[0] |= (a<<24|b<<16|c<<8);
		write_tagmem(tagmem);
	}

	if (opt_gpuon) {
		read_tagmem(tagmem);
		erase_tagmem();
		tagmem[2] |= (0x1 << 8);
		write_tagmem(tagmem);
	}

	if (opt_gpuoff) {
		read_tagmem(tagmem);
		erase_tagmem();
		tagmem[2] &= ~(0x1 << 8);
		write_tagmem(tagmem);
	}

	if (opt_reboot) {
		struct sched_param sched;
		sync();
		sysconregs[0x2/2] |= (0x1 << 15);
		sched.sched_priority = 99;
		sched_setscheduler(0, SCHED_FIFO, &sched);
		while(1);
	}

	if (opt_greenledoff) sysconregs[0x10/2] &= ~(0x1 << 15);
	if (opt_greenledon) sysconregs[0x10/2] |= (0x1 << 15);
	if (opt_redledoff) sysconregs[0x10/2] &= ~(0x1 << 14);
	if (opt_redledon) sysconregs[0x10/2] |= (0x1 << 14);

	if (opt_adc) {
		int x;
		// configure ADC:
		switch (getbaseboardid()) {
			case 2:
                                adcregs[0] = 0x28;
				break;
			case 6:
			case 7:
                                adcregs[0] = 0x18;
				break;
			default: // if unknown baseboard, uses no an_sel
				// but assumes ADC is there
                                adcregs[0] = 0x8;
				break;
		}
                adcregs[1] = 0x3f; // enable all 6 channels
		usleep(500000); // allow time for conversions
		for (i = 1; i <= 6; i++) {
			x = (signed short)adcregs[i + 1];
			if (i > 2) x = (x * 1006)/200;
			x = (x * 2048)/0x8000;
			printf("adc%d=%d\n", i, x);
		}
	}


skiprtc:

	/* Should be last! */
	if (opt_watchdog) {
		struct sched_param sched;
		int fd, r;
		char c;
		daemon(0, 0);
		signal(SIGHUP, SIG_IGN);
		sched.sched_priority = 98;
		sched_setscheduler(0, SCHED_FIFO, &sched);
		if (opt_autofeed) {
			unsigned int us = 60000000;
			if (wdog == 0) {
				us = 100000;
			} else if (wdog == 1) {
				us = 1000000;
			} else if (wdog == 2) {
				us = 5000000;
			}
			for (;;) {
				sysconregs[0xe/2] = wdog;
				usleep(us);
			}
		}
		/* Single character writes to /dev/watchdog keep it fed */
		mknod("/dev/watchdog", S_IFIFO|0666, 0);
		for(;;) {
			fd = open("/dev/watchdog", O_RDONLY);
			assert (fd != -1);
			do {
				r = read(fd, &c, 1);
				if (c > '3' || c < '0') c = '3';
				sysconregs[0xe/2] = c - '0';
			} while (r > 0);
			close(fd);
		}
	}


	return 0;
}
